FORMAT: 1A
HOST: https://api.tookanapp.com/v2

# Tookan API

- The Tookan API is a RESTful web service for developers to programmatically interact with Tookan’s data and real-time delivery management functionality.

- Every bit of data exchanged between clients and the API is JSON over HTTPS.

- The base URL for the Tookan API is https://api.tookanapp.com , all the requests on this url use post method and we need to add the specific end points mentioned below to this URL. Example, if you want to create a task in Tookan, you will Post to the below API: https://api.tookanapp.com/v2/create_task

- All sample requests in this documentation are formatted for cURL.

- API key is mandatory in all the API's request.

- All parameters marked with * are  mandatory  otherwise optional.

- If you have questions about using the API, want to share some feedback, or have come across a bug you'd like to report, write us an email at contact@tookanapp.com or submit a request through our Support Center.

- Tookan API uses key based authentication method. You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key from v2 section.

### Data Types & Response Format

The API we have follows all the following DATATYPES and Response Formats.

- Throughout the api the date format we recommend is YYYY-MM-DD HH:MM:SS. Explore http://gr2m.github.io/moment-parseformat/ for more formats.
- The response format will be JSON having status, message and data key.
        
        {
            "message": "Successful",
            "status": 200,
            "data": {}
        }

### Error Codes

When something is wrong with a request, the API will respond with a non-`200` status code in the response. To help you better understand the problem, where possible, the API overloads a number of different error codes so your application logic has as much visibility as possible into what has gone wrong.

 `100`  -- PARAMETER_MISSING <br>
 `101`  -- INVALID_KEY <br>
 `200`  -- ACTION_COMPLETE <br>
 `201`  -- SHOW_ERROR_MESSAGE <br>
 `404`  -- ERROR_IN_EXECUTION <br>

### Timezones

How are timezones handled in Tookan?

- Here is the link to find your timezone

https://timezones.tookanapp.com


- In Dashboard

When a task is created from Tookan Dashboard the local time zone from where the task is being created is considered.

Example: Let’s say a task is created in Singapore, the time zone considered is GMT +8hrs.

- In Bulk Upload

In the case of bulk upload of tasks, the time zone of the admin account is taken into consideration while tasks are created.

Example: Let’s say an admin in the US(say A for convenience) has created a manager(say M) in India. When this manager(M) creates tasks using the bulk upload the timezone of Admin(A) and tasks are created in US TimeZone.

- Using Tookan API

Tookan API accepts a request body parameter named “timezone” which is the Timezone difference with UTC in minutes. When a task is created with local time(say X), and timezone(+Y). Y minutes are added to X to make it UTC time.

- How to get the Timezone difference with UTC in minutes?

Let’s say I am creating a task in India’s time which is five and half hours ahead of UTC time (+05:30), convert five and half hours into minutes i.e 330 minutes. Since India’s time is ahead of UTC time to convert it into UTC time 330 minutes has to be subtracted from it. So, timezone is -330.

### Task Statuses

Below mentioned are the values of the `job_status` parameters of the respective Task Status:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td style="padding-left: 0;" colspan="1"><strong>Status</strong><td style="padding-left: 0;" colspan="1"><strong>Value </strong></td><td style="padding-left: 0;" colspan="1"><strong>Description </strong></td></tr>
<tr><td style="padding-left: 0;" >Assigned</td><td > <code>0</code></td><td>The task has been assigned to a agent.</td></tr>
<tr><td style="padding-left: 0;" >Started</td><td><code>1</code></td><td>The task has been started and the agent is on the way. This will appear as a light-blue pin on the map and as a rectangle in the assigned category on the left.</td></tr>
<tr><td style="padding-left: 0;" >Successful</td><td><code>2</code></td><td>The task has been completed successfully and will appear as a green pin on the map and as a rectangle in the completed category on the left.</td></tr>
<tr><td style="padding-left: 0;" >Failed</td><td><code>3</code></td><td>The task has been completed unsuccessfully and will appear as red pin on the map and as a rectangle in the completed category on the left.</td></tr>
<tr><td style="padding-left: 0;" >InProgress/Arrived</td><td><code>4</code></td><td>The task is being performed and the agent has reached the destination. This will appear as a dark-blue pin on the map and as a rectangle in the assigned category on the left.</td></tr>
<tr><td style="padding-left: 0;" >Unassigned</td><td><code>6</code></td><td>The task has not been assigned to any agent and will appear as a grey pin on the map and as a rectangle in the unassigned category on the left.</td></tr>
<tr><td style="padding-left: 0;" >Accepted/Acknowledged</td><td><code>7</code></td><td> The task has been accepted by the agent which is assigned to him.</td></tr>
<tr><td style="padding-left: 0;" >Decline</td><td><code>8</code></td><td> The task has been declined by the agent which is assigned to him.</td></tr>
<tr><td style="padding-left: 0;" >Cancel</td><td><code>9</code></td><td> The task has been cancelled by the agent which is accepted by him.</td></tr>
<tr><td style="padding-left: 0;" >Deleted</td><td><code>10</code></td><td>When the task is deleted from the Dashboard.</td></tr>
</table>

### Custom Fields 

We support a variety of Custom Fields/Data Types which you can create and manage from the Templates section from your Tookan Dashboard. As described below, you can utilize the "meta_data" key in the /create_task API calls, to send custom data for each task. "meta_data" or "pickup_meta_data" key should be detailed as follows - 

1. Array of Objects, where each Object consists of two keys - "label" - which is the name of the custom field key, as shown in the template settings page and "data" with the value of that key. Both the keys should be of string Data Type.
For ex - 
        
        [{
            "label": "Price",
            "data":"10"
        }]
        
2. All the Custom Field Data Types work in the similar fashion, except the following - 
    
    a. Checklist 

        {
            "label": "PackageType",
            "data":"A,B,C"
        }
        
    comma separated values that you want to display in task details. If you skip the "label" or "data" key, it will populate the checklist as per the template settings. 
        
    b. Tables 
    
        {
            "label": "DeliveryDetails",
            "data":[
                ["car","123"],
                ["bike","234"],
                ["scooter","456"]
            ]
        }
        
    data key should be a 2D Array, with the number of each element in the parent array are different rows and each element in the child arrays are values of each key, as per your template table settings. If you send different number of elements in any particular row, then the complete row will be ignored. For sending the location datatype within a table, you can send the value in the following format - 
        
            {
                lat" :"22.44",
                "lng":"34.4555",
                "add":"srilanka"
            }
            
    So, in this case, a sample row would look like this - 

        [
            "car",
            "123", 
            { 
                "lat":"22.44", 
                "lng":"34.4555", 
                "add":"srilanka 
            }
        ] 
        
    c. Barcode Verification
    
        { 
            "label":"barode_custom_field", 
            "data":[ 
                { 
                    "display_name":"Barcode1", 
                    "data":"data1", 
                    "is_verified":0 
                }, 
                { 
                    "display_name":"Barcode2", 
                    "data":"data2", 
                    "is_verified":1 
                } 
            ] 
        }

You can pass the array of objects and each object should contains these keys and act as a one barcode value.

If you have any questions regarding Custom Fields, you can reach out to us, with your questions on support@tookanapp.com 

### NPM Module

Refer to Tookan's NPM Module <b><a href="https://www.npmjs.com/package/tookan-api">tookan-api</a></b> to directly access tookan's APIs.

# Group Task

## Create Task [/create_task]

There are different types of tasks can be created inside Tookan depending on the workflow you have selected in your account for e.g. - pick & delivery task, appointment task etc. Please refer to appropriate API below according to your requirement. In case of any doubt, feel free to reach out to us at contact@tookanapp.com.

### Create a Pickup Task [POST]

This API is used to create a pickup task.
<br>
Request Body Parameters:
<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>Name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can generate a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">order_id</td><td>string</td> <td>Your can pass this key as your own transaction number which can be used to identify tasks in tookan</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_description</td><td> String </td><td>The description of the task to be done</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_phone</td><td>string</td><td> The contact number of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_name</td><td>string<br/>(optional)</td><td> The name of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_email</td><td>string <br/> (optional)</td><td> The email of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_address*</td><td>string</td><td>The address from which the pickup should be collected.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_latitude</td><td>string <br/> (optional)</td><td> This is the latitiude of the  pickup location</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_longitude</td><td>string <br/> (optional)</td><td>This is the longitude of the  pickup location</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_datetime*</td><td>string</td><td> This is time before which the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td> boolean <br/> (Fixed)</td><td>For a Pickup task, this is fixed to <code>1</code</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean <br/> (Fixed)</td><td>For a Pickup task this is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td> integer <br/> (Fixed)</td><td>For a Pickup task this is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tracking_link</td><td> boolean </td><td>If this value is <code>1</code> it will return a url in the response where the driver's movement can be tracked.if not no url will be returned </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> string </td><td>Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code>, for CST: <code>+360</code> (CDT:<code>+300</code>)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_custom_field_template</td><td>string</td> <td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td>string</td> <td> This is unique agent id given to each agent, if given the task will be assigned to the respective agent. You can get it from dashboard Menu>More>agents.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">p_ref_images</td><td>Array</td><td> This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_job_validate_otp</td><td>Number</td><td>4-digit OTP is allowed & It should start from 1000 onwards. Applicable only if Validate OTP extension is enabled.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">Barcode</td><td>string</td><td>Use this key to add Barcode to the Task</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
</table>


+ Request (application/json)

            {
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "order_id":"654321",
                "job_description":"groceries delivery",
                "job_pickup_phone":"+1201555555",
                "job_pickup_name":"7 Eleven Store",
                "job_pickup_email":"",
                "job_pickup_address":"114, sansome street, San Francisco",
                "job_pickup_latitude":"30.7188978",
                "job_pickup_longitude":"76.810296",
                "job_pickup_datetime":"2016-08-14 19:00:00",
                "pickup_custom_field_template":"Template_1",
                "pickup_meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "team_id":"",
                "auto_assignment":"0",
                "has_pickup":"1",
                "has_delivery":"0",
                "layout_type":"0",
                "tracking_link":1,
                "timezone":"300",
                "fleet_id":"",
                "p_ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "notify":1,
                "tags":"",
                "barcode" : "11225544777",
                "geofence":0
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {
                    "tracking_link": "http://bit.ly/1LwzMJS",
                    "job_id": 5265,
                    "job_hash": "f02aac468aebde6ef46ed90532b4a417",
                    "job_token": "1444849200000",
                    "job_pickup_name": "7 Eleven Store",
                    "job_pickup_address": "frigate bay 1",
                    "geofence_details": [{
                                "region_id": 5215,
                                "region_name": "CHD"
                                }],
                  }
                }

### Create a Delivery Task [POST]

This API is used to create a Delivery Task.
<br>
Body Parameters :
<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can generate a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">order_id</td><td>string</td> <td>Your can pass this key as your own transaction number which can be used to identify tasks in tookan</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_description</td><td> String </td><td>The description of the task to be done</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_email</td><td> email <br/> (optional)</td><td>  This is email of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_username</td><td>String<br/>(optional)</td><td>This is the name of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_phone</td><td> String </td><td>This is the contact number of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_address*</td><td>String </td><td>This is the address of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">latitude</td><td>String  <br/> (optional)</td><td> This is the latitiude of the  pickup location if you have it. Otherwise leave it blank. We will get it through geocoding API</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">longitude</td><td>String  <br/> (optional)</td><td>This is the latitiude of the  pickup location if you have it. Otherwise leave it blank. We will get it through geocoding API</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_delivery_datetime*</td><td> Date/String </td><td>This is time before which the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td> boolean<br/> (Fixed)</td><td>For a delivery task this value is <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean<br/> (Fixed)</td><td>For a delivery task this value is <code>1</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td> integer<br/> (Fixed)</td><td>For a delivery task this value is <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tracking_link</td><td> boolean</td><td>If this value is <code>1</code> it will return a url in the respone where the driver's movement can be tracked. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> string </td><td>Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">custom_field_template</td><td>string</td><td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td>string</td> <td> This is unique agent id given to each agent, if given the task will be assigned to the respective agent. You can get it from dashboard Menu>More>agents.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ref_images</td><td>Array</td><td> This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_validate_otp</td><td>Number</td><td>4-digit Otp is allowed & It should start from 1000 onwards. Applicable only if Validate OTP extension is enabled.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">Barcode</td><td>string</td><td>Use this key to add Barcode to the Task</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
</table>
+ Request (application/json)

            {
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "order_id":"654321",
                "job_description":"groceries delivery",
                "customer_email":"john@example.com",
                "customer_username":"John Doe",
                "customer_phone":"+12015555555",
                "customer_address":"frigate bay 2",
                "latitude":"30.7188978",
                "longitude":"76.810298",
                "job_delivery_datetime":"2016-08-14 21:00:00",
                "custom_field_template":"Template_1",
                "meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "team_id":"",
                "auto_assignment":"0",
                "has_pickup":"0",
                "has_delivery":"1",
                "layout_type":"0",
                "tracking_link":1,
                "timezone":"-330",
                "fleet_id":"636",
                "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png","http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "notify":1,
                "tags":"",
                "barcode" : "11225544777",
                "geofence":0
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {
                    "tracking_link": "http://bit.ly/1OqtCS9",
                    "job_id": 5268,
                    "job_hash": "6e419074d9cbaa2ec52754e852b91e21",
                    "job_token": "1444856400000",
                    "customer_name": "John Doe",
                    "customer_address": "frigate bay 2",
                    "geofence_details": [{
                                "region_id": 5215,
                                "region_name": "CHD"
                                }],
                  }
                }

### Create a Pickup and Delivery Task [POST]

This api is used to create Pickup and delivery task.
<br>
Request Body Parameters :
<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">order_id</td><td>string</td> <td>Your can pass this key as your own transaction number which can be used to identify tasks in tookan</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_description</td><td> String </td><td>The description of the task to be done</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_phone</td><td>string</td><td> The contact number of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_name</td><td>string <br/> (optional) </td><td> The name of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_email</td><td>string <br/> (optional)</td><td> The email of the person from whom the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_address*</td><td>string</td><td>The address from which the pickup should be collected.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_latitude</td><td>string <br/> (optional)</td><td> This is the latitiude of the  pickup location</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_longitude</td><td>string <br/> (optional)</td><td>This is the longitude of the  pickup location</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_datetime*</td><td>string</td><td> This is time before which the pickup should be collected</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_custom_field_template</td><td>string</td> <td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_email</td><td> email <br/> (optional)</td><td>  This is email of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_username</td><td>String <br/> (optional)</td><td>This is the name of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_phone</td><td> String </td><td>This is the contact number of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_address*</td><td>String </td><td>This is the address of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">latitude</td><td>String <br/> (optional) </td><td> This is the latitiude of the  delivery location </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">longitude</td><td>String <br/> (optional) </td><td>This is the longitude of the  delivery location</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_delivery_datetime*</td><td> Date/String </td><td>This is time before which the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">custom_field_template</td><td>string</td> <td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> Integer</td><td>Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td> boolean<br/> (Fixed)</td><td>For a pickup and delivery task this value is fixed to <code>1</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean<br/> (Fixed)</td><td>For a pickup and delivery task this value is fixed to <code>1</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td> integer<br/> (Fixed)</td><td>For a pickup and delivery task this value is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tracking_link</td><td> boolean</td><td>If this value is <code>1</code> it will return a url in the respone where the driver's movement can be tracked. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td>string</td> <td> This is unique agent id given to each agent, if given the task will be assigned to the respective agent. You can get it from dashboard Menu>More>agents.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">p_ref_images</td><td>Array</td><td>(Pickup) This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ref_images</td><td>Array</td><td>(Delivery) This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_validate_otp</td><td>Number</td><td>1 - OTP won't be required, 0 - OTP will be required. Applicable only if Validate OTP extension is enabled. Default value is 0.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickup_job_validate_otp</td><td>Number</td><td>4-digit OTP is allowed & It should start from 1000 onwards. Applicable only if Validate OTP extension is enabled.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_validate_otp</td><td>Number</td><td>4-digit Otp is allowed & It should start from 1000 onwards. Applicable only if Validate OTP extension is enabled.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ride_type</td><td>number</td><td>0 for Non-Pool Task, 1 for Pool Task.</td></tr>
</table>

<br>

Response Body Parameters : 
<table>
<tr><td colspan="1"><strong>Name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">message</td><td>string</td><tdThis says whether the request is successful or not></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">status</td><td>number</td><td>This should be mapped with the error codes mention in error codes section above.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">data</td><td>Object</td> <td>This gives the information about the task like pickup_tracking_link,delivery_tracing_link,job_id, job_token,
pickup_hash, delivery_hash</td></tr>
</table>

+ Request (application/json)

            {
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "order_id":"654321",
                "team_id":"",
                "auto_assignment":"0",
                "job_description":"groceries delivery",
                "job_pickup_phone":"+1201555555",
                "job_pickup_name":"7 Eleven Store",
                "job_pickup_email":"",
                "job_pickup_address":"frigate bay 1",
                "job_pickup_latitude":"30.7188978",
                "job_pickup_longitude":"76.810296",
                "job_pickup_datetime":"2016-08-14 19:00:00",
                "customer_email":"john@example.com",
                "customer_username":"John Doe",
                "customer_phone":"+12015555555",
                "customer_address":"frigate bay 2",
                "latitude":"30.7188978",
                "longitude":"76.810298",
                "job_delivery_datetime":"2016-08-14 21:00:00",
                "has_pickup":"1",
                "has_delivery":"1",
                "layout_type":"0",
                "tracking_link":1,
                "timezone":"-330",
                "custom_field_template":"Template_1",
                "meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "pickup_custom_field_template":"Template_2",
                "pickup_meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "fleet_id":"",
                "p_ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png","http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png","http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "notify":1,
                "tags":"",
                "geofence":0,
                "ride_type":0
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {
                            "pickup_tracking_link": "http://bit.ly/1htQjX9",
                            "delivery_tracing_link": "http://bit.ly/1jSBizX",
                            "job_id": 5233,
                            "job_token": "1444849200000",
                            "pickup_hash": "e70c492a098f1e741bd47c44ba5a8530",
                            "delivery_hash": "f30a06756a922ee36b3fcc58ec5072ea",
                            "customer_name": "John Doe",
                            "customer_address": "frigate bay 2",
                            "geofence_details": [{
                                "region_id": 5215,
                                "region_name": "CHD"
                                }],
                          }
                }

### Create an Appointment Task [POST]

This api is used to create an appointment task.
<br>
Request Body Parameters :
<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">order_id</td><td>string</td> <td>Your can pass this key as your own transaction number which can be used to identify tasks in tookan</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_email</td><td> email <br/> (optional)</td><td> Customer email</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_username</td><td>String</td><td>customer name to whom the product should be delivered.</tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_phone</td><td> String</td><td> The contact number of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_address*</td><td>String </td><td>The address to which the product should be delivered.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">latitude</td><td>number  <br/> (optional)</td><td>The latitude of the location of customer address</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">longitude</td><td>number  <br/> (optional)</td><td>The longitude of the location of customer address</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_description</td><td> String </td><td> The description of the task to be done</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_datetime*</td><td> Date/String </td><td> This is the start time of the appointment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_delivery_datetime*</td><td> Date/String </td><td> Time before which the appointment should be completed</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> Integer</td><td> Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">custom_field_template</td><td>string</td> <td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td>boolean<br/> (Fixed)</td><td>For an appointment task this value is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td> boolean <br/> (Fixed)</td><td>For an appointment task this value is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td> number <br/> (Fixed)</td><td>For an appointment task this value is fixed to <code>1</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tracking_link</td><td> boolean</td><td> If this value is <code>1</code> it will return a url in the respone where the driver's movement can be tracked</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td>string</td> <td> This is unique agent id given to each agent, if given the task will be assigned to the respective agent. You can get it from dashboard Menu>More>agents.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ref_images</td><td>Array</td><td>This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
</table>
+ Request (application/json)

            {
                "customer_email":"john@example.com",
                "order_id":"654321",
                "customer_username":"John Doe",
                "customer_phone":"+919999999999",
                "customer_address":"Powai Lake, Powai, Mumbai, Maharashtra, India",
                "latitude":"28.5494489",
                "longitude":"77.2001368",
                "job_description":"Beauty services",
                "job_pickup_datetime":"2016-10-30 16:00:00",
                "job_delivery_datetime":"2016-10-30 17:00:00",
                "has_pickup":"0",
                "has_delivery":"0",
                "layout_type":"1",
                "tracking_link":1,
                "timezone":"-330",
                "custom_field_template":"Template_1",
                "meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "team_id":"",
                "auto_assignment":"0",
                "fleet_id":"",
                "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png","http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "notify":1,
                "tags":"",
                "geofence":0
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {
                            "tracking_link": "http://bit.ly/1GA4z7e",
                            "job_id": 5236,
                            "job_hash": "67657b3ed35c5548d7806d9eafd22e43",
                            "job_token": "1446220800000",
                            "customer_name": "John Doe",
                            "customer_address": "Powai Lake, Powai, Mumbai, Maharashtra, India",
                            "geofence_details": [{
                                "region_id": 5215,
                                "region_name": "CHD"
                                }],
                            }
                }

### Create a Field Workforce Task [POST]

This api is used to create a field workforce task.
<br>
Request Body Parameters :
<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">order_id</td><td>string</td> <td>Your can pass this key as your own transaction number which can be used to identify tasks in tookan</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_email</td><td> email <br/> (optional)</td><td> Customer email</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_username</td><td>String</td><td>customer name to whom the product should be delivered.</tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_phone</td><td> String</td><td> The contact number of the customer to whom the product should be delivered</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">customer_address*</td><td>String </td><td>The address to which the product should be delivered.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">latitude</td><td>number  <br/> (optional)</td><td>The latitude of the location of customer address</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">longitude</td><td>number  <br/> (optional)</td><td>The longitude of the location of customer address</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_description</td><td> String </td><td> The description of the task to be done</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_pickup_datetime*</td><td> Date/String </td><td> This is the start time of the appointment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_delivery_datetime*</td><td> Date/String </td><td> Time before which the appointment should be completed</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> Integer</td><td> Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">custom_field_template</td><td>string</td> <td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">meta_data</td><td>json array</td> <td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.)</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td>boolean<br/> (Fixed)</td><td>For an appointment task this value is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td> boolean <br/> (Fixed)</td><td>For an appointment task this value is fixed to <code>0</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td> number <br/> (Fixed)</td><td>For an field workforce task this value is fixed to <code>2</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tracking_link</td><td> boolean</td><td> If this value is <code>1</code> it will return a url in the respone where the driver's movement can be tracked</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td>string</td> <td> This is unique agent id given to each agent, if given the task will be assigned to the respective agent. You can get it from dashboard Menu>More>agents.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ref_images</td><td>Array</td><td>This is an array of strings containing links of images.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
</table>
+ Request (application/json)

            {
                "customer_email":"john@example.com",
                "order_id":"654321",
                "customer_username":"John Doe",
                "customer_phone":"+919999999999",
                "customer_address":"Powai Lake, Powai, Mumbai, Maharashtra, India",
                "latitude":"28.5494489",
                "longitude":"77.2001368",
                "job_description":"Beauty services",
                "job_pickup_datetime":"2016-10-30 16:00:00",
                "job_delivery_datetime":"2016-10-30 17:00:00",
                "has_pickup":"0",
                "has_delivery":"0",
                "layout_type":"2",
                "tracking_link":1,
                "timezone":"-330",
                "custom_field_template":"Template_1",
                "meta_data": [{"label":"Price","data":"100"},{"label":"Quantity","data":"100"}],
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "team_id":"",
                "auto_assignment":"0",
                "fleet_id":"",
                "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png","http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
                "notify":1,
                "tags":"",
                "geofence":0
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {
                            "tracking_link": "http://bit.ly/1GA4z7e",
                            "job_id": 5236,
                            "job_hash": "67657b3ed35c5548d7806d9eafd22e43",
                            "job_token": "1446220800000",
                            "customer_name": "John Doe",
                            "customer_address": "Powai Lake, Powai, Mumbai, Maharashtra, India",
                            "geofence_details": [{
                                "region_id": 5215,
                                "region_name": "CHD"
                                }],
                            }
                }

## Create Multiple Tasks [/create_multiple_tasks]

### Create Multiple Pickup And Delivery Tasks [POST]
This API is used to create multiple pickup and delivery tasks for the fleets at once. 

Request Body Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can generate a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td> String </td><td>Id of the fleet to which this task is to be assigned, optional.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone</td><td>string</td><td>Timezone of the country or location in numerical format. Eg - timezone for India = -330.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup</td><td>boolean</td> <td> Boolean key containing 1 if these are pickup tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery</td><td>boolean</td><td>Boolean key containing 1 if these are delivery tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type</td><td>string</td><td>Set it as 0 (PICKUP_AND_DELIVERY), 1 (APPOINTMENT) or 2 (FOS) depending upon the type of layout.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>string</td> <td> This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td><td>Boolean key containing the value 0 if the task is not to be assigned automatically to the fleet.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td> String </td><td>This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_validate_otp</td><td>Number</td><td>1 - OTP won't be required, 0 - OTP will be required. Applicable only if Validate OTP extension is enabled. Default value is 0.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">deliveries</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, tie, phone, template_name, template_data, ref_images, email, order_id where address defines the address of the customer to whom the product should be delivered, name defines the name  of the customer, job_description defines the description of the task, latitude defines the latitude of the pickup location if you have it, otherwise leave it blank. We'll get it through geocoding API, longitude and latitude defines the long and lat of the pick up, time defines the time before the pickup should be collected, phone defines the contact number of the customer, template_name defines the custom fields template name that is predefined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value. (Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the  email of the customer to whom the product should be delivered,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickups*</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, time, phone, template_name, template_data, ref_images, email, order_id where address defines the address from which the pickup should be collected, name defines the name of the person from whom the pickup should be collected, job_description defines the description of the task to be done, latitude and longitude defines the lat and long of the pick up location, time defines the time before which the pickup should be collected,phone defines the contact number of the person from whom the pickup should be collected,template_name defines the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the email of the person from whom the pickup should be collected,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>
</table>


+ Request (application/json)   

        {
          "api_key": "c3e46bc0bbdc2d6cdf22f4dae426581259435bd522fd98b30f5baf939b9ce2ba",
          "fleet_id": 19750,
          "timezone": -330,
          "has_pickup": 1,
          "has_delivery": 1,
          "layout_type": 0,
          "geofence": 0,
          "team_id":"",
          "auto_assignment": 0,
          "tags": "",
          "pickups": [{
            "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
            "latitude": 30.7333148,
            "longitude": 76.7794179,
            "time": "2017-08-14 17:24:00",
            "phone": "+911234567890",
            "job_description":"",
            "template_name": "Template_1",
            "template_data": [{
                "label": "Price",
                "data": "100"
             }, {
                "label": "Quantity",
                "data": "100"
            }],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "name": "Saurabh",
            "email": "saurabh@saurabh.com",
            "order_id": "12234556",
            "job_description": "Job description goes here"
          }],
          "deliveries": [{
            "address": "Chandigarh Railway Station, Daria, Chandigarh, India",
            "latitude": 30.7022191,
            "longitude": 76.82247009999992,
            "time": "2017-08-14 17:30:00",
            "phone": "+913242342342",
            "job_description":"",
            "template_name": "Template_1",
            "template_data": [
            {
              "label": "Price",
              "data": "100"
            },
            {
              "label": "Quantity",
              "data": "100"
            }
            ],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "name": "Saurabh",
            "email": "saurabh@saurabh.com",
            "order_id": "123456",
            "job_description": "Job description goes here"
          }]
        }
        
        
+ Response 200 (application/json)

        {
            "message":"Successful",
            "status":200,
            "data":{
            "pickups":[{
                "job_id":254737,
                "job_hash":"fc0f4e89d604a180bcb33a5aebdcd146",
                "job_token":"25473715022796802388950",
                "status":true,
                "auto_assignment_data":0,
                "order_id":"12234556",
                "result_tracking_link":"https://goo.gl/53jKDJ",
                "new_agent_task_insertion_data":[]}],
            "deliveries":[{
                "job_id":254738,
                "job_hash":"bc41a6e7dcfd3716d8540fbcd6e32fb9",
                "job_token":"25473715022796802388950",
                "status":true,
                "auto_assignment_data":0,
                "order_id":"123456",
                "result_tracking_link":"https://goo.gl/r3Gj4L",
                "new_agent_task_insertion_data":[]}]
                "geofence_details":[{
                    "region_id":5215,
                    "region_name":"CHD"}]
                }
        }

### Create Multiple Pickup Tasks [POST]
This API is used to create multiple pickup tasks for the fleets at once.

Request Body Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can generate a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td> String </td><td>Id of the fleet to which this task is to be assigned, optional.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td>string</td><td>Timezone of the country or location in numerical format. Eg - timezone for India = -330.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td>boolean</td> <td> Boolean key containing 1 if these are pickup tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean</td><td>Boolean key containing 1 if these are delivery tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td>string</td><td>Set it as 0(PICKUP_AND_DELIVERY), 1(APPOINTMENT) or 2(FOS) depending upon the type of layout.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>string</td> <td> This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td><td>Boolean key containing the value 0 if the task is not to be assigned automatically to the fleet.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td> String </td><td>This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickups*</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, time, phone, template_name, template_data, ref_images, email, order_id where address defines the address from which the pickup should be collected, name defines the name of the person from whom the pickup should be collected, job_description defines the description of the task to be done, latitude and longitude defines the lat and long of the pick up location, time defines the time before which the pickup should be collected,phone defines the contact number of the person from whom the pickup should be collected,template_name defines the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the email of the person from whom the pickup should be collected,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>
</table>


+ Request (application/json)   

        {
          "api_key": "c3e46bc0bbdc2d6cdf22f4dae426581259435bd522fd98b30f5baf939b9ce2ba",
          "fleet_id": "",
          "timezone": -330,
          "has_pickup": 1,
          "has_delivery": 0,
          "layout_type": 0,
          "geofence": 0,
          "auto_assignment": 0,
          "team_id":"",
          "tags": "",
          "pickups": [{
            "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
            "name": "Saurabh",
            "latitude": "30.7333148",
            "longitude": "76.7794179",
            "time": "2017-08-14 17:29:00",
            "phone": "+911234567890",
            "job_description":"",
            "template_name": "Template_1",
            "template_data": [
            {
              "label": "Price",
              "data": "100"
            },
            {
              "label": "Quantity",
              "data": "100"
            }
            ],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "order_id": "123456",
            "job_description": "Job description goes here"
          }]
        }
        
        
+ Response 200 (application/json)

        {
        "message":"Successful",
        "status":200,
        "data":{
            "pickups":[{
            "job_id":254746,
            "job_hash":"4e77cf8abc38bb1a81facaf7e4499550",
            "job_token":"25474615022800065310310",
            "status":true,
            "auto_assignment_data":0,
            "order_id":"123456",
            "result_tracking_link":"https://goo.gl/GMYjmy",
            "new_agent_task_insertion_data":[]}]
            "geofence_details":[{
                "region_id":5215,
                "region_name":"CHD"}]
            }
        }

### Create Multiple Delivery Tasks [POST]

This API is used to create multiple delivery tasks for the fleets at once.

Request Body Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can generate a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">fleet_id</td><td> String </td><td>Id of the fleet to which this task is to be assigned, optional.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td>string</td><td>Timezone of the country or location in numerical format. Eg - timezone for India = -330.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td>boolean</td> <td> Boolean key containing 1 if these are pickup tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean</td><td>Boolean key containing 1 if these are delivery tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td>string</td><td>Set it as 0(PICKUP_AND_DELIVERY), 1(APPOINTMENT) or 2(FOS) depending upon the type of layout.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>string</td> <td> This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">ignore_customer_lat_long</td><td>integer</td><td> This is used to add address sent in request body  otherwise tookan fetch customer by phone number  saved in tookan database and use that customer adddress   .</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean</td><td>Boolean key containing the value 0 if the task is not to be assigned automatically to the fleet.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td> String </td><td>This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">deliveries*</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, tie, phone, template_name, template_data, ref_images, email, order_id where address defines the address of the customer to whom the product should be delivered, name defines the name  of the customer, job_description defines the description of the task, latitude defines the latitude of the pickup location if you have it, otherwise leave it blank. We'll get it through geocoding API, longitude and latitude defines the long and lat of the pick up, time defines the time before the pickup should be collected, phone defines the contact number of the customer, template_name defines the custom fields template name that is predefined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value. (Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the  email of the customer to whom the product should be delivered,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>
</table>


+ Request (application/json)   

        {
          "api_key": "c3e46bc0bbdc2d6cdf22f4dae426581259435bd522fd98b30f5baf939b9ce2ba",
          "fleet_id": "",
          "timezone": -330,
          "has_pickup": 0,
          "has_delivery": 1,
          "layout_type": 0,
          "geofence": 0,
          "team_id":"",
          "auto_assignment": 0,
          "tags": "",
          "deliveries": [{
            "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
            "name": "Saurabh",
            "latitude": 30.66776609999999,
            "longitude": 76.78622870000004,
            "time": "2017-08-14 17:31:00",
            "phone": "+911234567890",
            "job_description":"",
            "template_name": "Template_1",
            "template_data": [
            {
              "label": "Price",
              "data": "100"
            },
            {
              "label": "Quantity",
              "data": "100"
            }
            ],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "email": null,
            "order_id": "123345566",
            "job_description": "Job description goes here"
          }]
        }
        
        
+ Response 200 (application/json)

        {
            "message":"Successful",
            "status":200,
            "data":
                {
                "deliveries":[
                    {
                        "job_id":254751,
                        "job_hash":"5e0e634e7bd29fe36319b53617698a2a",
                        "job_token":"25475115022801325504460",
                        "status":true,
                        "auto_assignment_data":0,
                        "order_id":"123345566",
                        "result_tracking_link":"https://goo.gl/agt8MV",
                        "new_agent_task_insertion_data":[]
                    }
                ]
                "geofence_details":[{
                "region_id":5215,
                "region_name":"CHD"
                }]
                }
        }

## Create Task From CSV [/import_bulk_tasks_csv]

### Create Tasks From CSV [POST]

This API is used to create tasks from CSV.

Request File Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>Name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tasks_csv</td><td>file</td> <td>File with extension .csv that contains tasks in proper format as described in “Create Task”</td></tr>
</table>

Request Body Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>Name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td> Integer</td><td>Timezone difference with UTC in minutes for e.g., For PST:<code>+480</code> (PDT: <code>+420</code>),For MST <code>+420</code> (MDT:<code>+360</code>) for EST: <code>+300</code>(EDT:<code>+240</code>), for AEST: <code>-600</code> (AEDT: <code>-660</code>), for IST: <code>-330</code></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">team_id</td><td>integer</td> <td>This is the Unique id of every team. You can get it from the dashBoard. More>teams>respective id of the team will displayed.</td></tr><tr><td style="padding-right: 40px; width: 140px;">auto_assignment</td><td>boolean (optional)</td> <td> If this value is <code>1</code> The task will be auto assigned to the members of the specific team mentioned. or if this value is <code>0</code> it will be unassigned task created. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">notify</td><td>integer (optional)</td><td>This is used to enable the notifications.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">geofence</td><td>integer (optional)</td><td>This is used to enable the geofencing.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">tags</td><td>string (optional)</td><td> This is a string containing comma separated tags as filters for agents in auto assignment.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">p_c_f</td><td>string (optional)</td><td>Pickup custom field, used to define the custom field in csv for pickup.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">d_c_f</td><td>string (optional)</td><td>Delivery custom field, used to define the custom field in csv for delivery.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">search_add_on</td><td>integer (optional)</td><td>This is used to enable search add on (if applicable)</td></tr>
</table>

+ Request (appliation/json)

        {
            "api_key":"eaac56717958fa6664a9c5a0a29a43810a0fcda90be26a3e023b2f70f9ffa05",
            "timezone":"-330",
            "team_id":126,
        
            "notify":1,
            "geofence":0,
            "tags":"basic, premium",
            "p_c_f":"Pickups",
            "d_c_f":"Deliveries",
            "search_add_on":0
        }

+ Response 200 (application/json)

        {
            "message":"ACTION_COMPLETE_2",
            "Status":205,
            "Data":{}
        }

## Create Task For Form User [/create_task_for_form_user]

### Create Tasks For Form User [POST]

This API is used to create tasks for form user.


Request Body Parameters:

<table class="humanColumnApiDescription markdown formalTheme">
<tr><td colspan="1"><strong>Name</strong><td colspan="1"><strong>Type</strong><td colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">api_key</td><td>string</td> <td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">timezone*</td><td>string</td><td>Timezone of the country or location in numerical format. Eg - timezone for India = -330.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_pickup*</td><td>boolean</td> <td> Boolean key containing 1 if these are pickup tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">has_delivery*</td><td>boolean</td><td>Boolean key containing 1 if these are delivery tasks.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">layout_type*</td><td>string</td><td>Set it as 0 (PICKUP_AND_DELIVERY), 1 (APPOINTMENT) or 2 (FOS) depending upon the type of layout.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">deliveries*</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, tie, phone, template_name, template_data, ref_images, email, order_id where address defines the address of the customer to whom the product should be delivered, name defines the name  of the customer, job_description defines the description of the task, latitude defines the latitude of the pickup location if you have it, otherwise leave it blank. We'll get it through geocoding API, longitude and latitude defines the long and lat of the pick up, time defines the time before the pickup should be collected, phone defines the contact number of the customer, template_name defines the custom fields template name that is predefined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value. (Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the  email of the customer to whom the product should be delivered,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">pickups*</td><td>JSON array</td><td>Array of objects containing address, name, job_description, latitude, longitude, time, phone, template_name, template_data, ref_images, email, order_id where address defines the address from which the pickup should be collected, name defines the name of the person from whom the pickup should be collected, job_description defines the description of the task to be done, latitude and longitude defines the lat and long of the pick up location, time defines the time before which the pickup should be collected,phone defines the contact number of the person from whom the pickup should be collected,template_name defines the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_), template_data defines an array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template.),ref_images defines an array of strings containing links of images,email defines the email of the person from whom the pickup should be collected,order_id can be  passed as your own transaction number which can be used to identify tasks in tookan.</td></tr>


<tr><td style="padding-right: 40px; width: 140px;">is_multiple_tasks*</td><td>boolean</td> <td>Boolean key containing 1.</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">vendor_email_id*</td><td>email</td> <td>Registered email of form user. </td></tr>
<tr><td style="padding-right: 40px; width: 140px;">domain_name*</td><td>string </td><td>Domain name of form.</td></tr>
</table>

+ Request (appliation/json)
        
        {
          "api_key": "YOUR_API_KEY",
          "timezone": -330,
          "has_pickup": 1,
          "has_delivery": 1,
          "layout_type": 0,
          "deliveries": [{
            "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
            "name": "Saurabh",
            "latitude": 30.66776609999999,
            "longitude": 76.78622870000004,
            "time": "2017-08-14 17:31:00",
            "phone": "+911234567890",
            "template_name": "Template_1",
            "template_data": [
            {
              "label": "Price",
              "data": "100"
            },
            {
              "label": "Quantity",
              "data": "100"
            }
            ],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "email": null,
            "job_description": "Job description goes here"
          }],
          "pickups": [{
            "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
            "name": "Saurabh",
            "latitude": "30.7333148",
            "longitude": "76.7794179",
            "time": "2017-08-14 17:29:00",
            "phone": "+911234567890",
            "template_name": "Template_1",
            "template_data": [
            {
              "label": "Price",
              "data": "100"
            },
            {
              "label": "Quantity",
              "data": "100"
            }
            ],
            "ref_images": ["http://tookanapp.com/wp-content/uploads/2015/11/logo_dark.png"],
            "job_description": "Job description goes here"
          }]
          "is_multiple_tasks" : 1,
          "vendor_email_id" : "nadeem@jungleworks.in",
          "domain_name" : "Your domain name"
        }
        
        
        
+ Response 200 (application/json)
{
    "message": "Successful",
    "status": 200,
    "data": {
        "pickups": [
            {
                "job_id": 351378,
                "job_hash": "1997e140c50a99556b69756147cad219",
                "job_token": "35137815413251963435918",
                "status": true,
                "auto_assignment_data": 0,
                "order_id": "12234556",
                "result_tracking_link": "https://k7ggd.app.goo.gl/XkPsGQ",
                "new_agent_task_insertion_data": []
            }
        ],
        "deliveries": [
            {
                "job_id": 351379,
                "job_hash": "23dccbd6038ba110ae91813360e1ba80",
                "job_token": "35137815413251963435918",
                "status": true,
                "auto_assignment_data": 0,
                "order_id": "123456",
                "result_tracking_link": "https://k7ggd.app.goo.gl/K7FeQ3",
                "new_agent_task_insertion_data": []
            }
        ]
    }
} 


## Get Task Details [/get_job_details]

### Get Task Details [POST]

This api is used to get the details of the task.
<br>
Request Body Parameters:
<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_ids*</td><td>array</td><td>You can get it from task details. You can send 100 job id's in single request.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">include_task_history</td><td>number</td><td>Enter 1, if you want task history. Otherwise, enter 0 in the key.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_additional_info </td><td>number</td><td>Enter 1, if you want Job Additional Details. Otherwise, enter 0 in the key.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">include_job_report </td><td>number</td><td>Enter 1, if you want to retreive the Job report. Otherwise, enter 0 in the key.</td></tr>
</table>
+ Request (application/json)

            {
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "job_ids":[5145, 1234],
                "include_task_history": 0,
                "job_additional_info" : 1,
                "include_job_report" : 0
            }

+ Response 200 (application/json)


        {
              "message": "Successful",
              "status": 200,
              "data": [
                {
                  "job_details_by_fleet": 189,
                  "fleet_id": 189,
                  "fleet_name": "Chandra",
                  "user_id": 222,
                  "customer_username": "Joey Tribianni",
                  "customer_phone": "+91 99869 06722",
                  "customer_email": "Joey@yahoo.com",
                  "is_customer_rated": 0,
                  "customer_comment": "",
                  "customer_rating": 0,
                  "job_pickup_email": null,
                  "job_pickup_name": "",
                  "job_pickup_phone": "0",
                  "job_latitude": "43.87274070000001",
                  "job_longitude": "-79.320782",
                  "job_address": "36 Pennock Crescent,Unionville,L3R,3M4 CA",
                  "job_status": 0,
                  "job_description": "#7717700",
                  "has_pickup": 0,
                  "completed_by_admin": 0,
                  "pickup_delivery_relationship": "1444471200000",
                  "job_pickup_datetime": "Invalid date",
                  "job_id": 5145,
                  "job_delivery_datetime": "12/06/2017 10:00 am",
                  "job_type": 1,
                  "job_pickup_latitude": "0",
                  "job_pickup_longitude": "0",
                  "job_pickup_address": "",
                  "job_acknowledge_text": null,
                  "job_acknowledge_status": 0,
                  "job_acknowledge_image": null,
                  "started_datetime": "",
                  "started_datetime_utc": "2017-12-06 12:29:47",
                  "started_datetime_local": "2017-12-06 17:59:47",
                  "completed_datetime_utc": "2017-12-06 12:37:16",
                  "completed_datetime_local": "2017-12-06 18:07:16",
                  "arrived_datetime_utc": "2017-12-06 12:37:16",
                  "arrived_datetime_local": "2017-12-06 18:07:16",
                  "acknowledged_datetime_utc": "2017-12-06 12:27:26",
                  "acknowledged_datetime_local": "2017-12-06 17:57:26",
                  "completed_datetime": "",
                  "arrived_datetime": "",
                  "acknowledged_datetime": "",
                  "total_distance_travelled": "0",
                   "tracking_link": "https://jngl.ml/5bCScff",
                  "task_history": []
                }
              ]
            }

## Get Task From Order ID [/get_job_details_by_order_id]

### Get Task Details From Order ID [POST]

This api is used to get the details of the task.
<br>
Request Body Parameters:
<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">order_ids*</td><td>array</td><td>This will be set by you.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">include_task_history</td><td>number</td><td>Enter 1, if you want task history. Otherwise, enter 0 in the key.</td></tr>
</table>
+ Request (application/json)

            {
                "api_key":"7fed9dc6f41eb088bb49ab5344685d13",
                "order_ids":["P000469","123"],
                "include_task_history": 0
            }

+ Response 200 (application/json)


        {
              "message": "Successful",
              "status": 200,
              "data": [
                {
                  "job_details_by_fleet": 189,
                  "user_id": 222,
                  "customer_username": "Joey Tribianni",
                  "customer_phone": "+91 99869 06722",
                  "customer_email": "Joey@yahoo.com",
                  "is_customer_rated": 0,
                  "customer_comment": "",
                  "customer_rating": 0,
                  "job_pickup_email": null,
                  "job_pickup_name": "",
                  "job_pickup_phone": "0",
                  "job_latitude": "43.87274070000001",
                  "job_longitude": "-79.320782",
                  "job_address": "36 Pennock Crescent,Unionville,L3R,3M4 CA",
                  "job_status": 0,
                  "job_description": "#7717700",
                  "has_pickup": 0,
                  "completed_by_admin": 0,
                  "pickup_delivery_relationship": "1444471200000",
                  "job_pickup_datetime": "Invalid date",
                  "job_id": 5145,
                  "job_delivery_datetime": "12/06/2017 10:00 am",
                  "job_type": 1,
                  "job_pickup_latitude": "0",
                  "job_pickup_longitude": "0",
                  "job_pickup_address": "",
                  "job_acknowledge_text": null,
                  "job_acknowledge_status": 0,
                  "job_acknowledge_image": null,
                  "started_datetime": "",
                  "completed_datetime": "",
                  "started_datetime_utc": "2017-12-06 12:29:47",
                  "started_datetime_local": "2017-12-06 17:59:47",
                  "completed_datetime_utc": "2017-12-06 12:37:16",
                  "completed_datetime_local": "2017-12-06 18:07:16",
                  "arrived_datetime_utc": "2017-12-06 12:37:16",
                  "arrived_datetime_local": "2017-12-06 18:07:16",
                  "acknowledged_datetime_utc": "2017-12-06 12:27:26",
                  "acknowledged_datetime_local": "2017-12-06 17:57:26",
                  "arrived_datetime": "",
                  "acknowledged_datetime": "",
                  "total_distance_travelled": "0",
                  "total_time_spent_at_task_till_completion" : "15",
                  "fleet_id": 189,
                  "tracking_link": "https://app.tookanapp.com/tracking/index.html?jobID=39802dace6589590ac5ab771f2cae4ba",
                  "custom_field": [
                      {
                        "label": "Price Test",
                        "value": "true",
                        "required": "true",
                        "data_type": "Number",
                        "app_side": "Get Fleet Input",
                        "data": ""
                      },
                      {
                        "label": "what happened",
                        "value": "true",
                        "required": "true",
                        "data_type": "Text",
                        "app_side": "Get Fleet Input",
                        "data": ""
                      },
                      {
                        "label": "wfwef",
                        "value": "true",
                        "required": "false",
                        "data_type": "Text",
                        "app_side": "Get Fleet Input",
                        "data": ""
                      }
                    ]
                  },
                  "task_history": []
                }
              ]
            }

## Edit Task [/edit_task]

### Edit Task [POST]

This api used to edit a task that has already been added.
<br>
Request Body Parameters : Every parameter is same as while creating a task  the only parameters that should added while editing a task is shown below.
<table>
<tr><td style="padding-left: 0;" colspan="1"><strong>Name</strong><td style="padding-left: 0;" colspan="1"><strong>Type</strong></td><td style="padding-left: 0;" colspan="1"><strong>Description</strong></td></tr>
<tr><td style="padding-right: 40px; width: 140px;">job_id*</td><td>string</td><td>This is the unique id given to every job which is returned while creating a task</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">meta_data</td><td>string</td><td>This is array of object containing label and data where label defines the custom field name and data will be his value.(Provided label should be in specified template</td></tr>
<tr><td style="padding-right: 40px; width: 140px;">custom_field_template</td><td>string</td><td>This is the custom fields template name that is pre-defined in your workflow page in the admin account and you just need to replace space in template with underscore(_).</td></tr>
</table>
+ Request (application/json)

            {
                "customer_email":"john@example.com",
                "customer_username":"John Doe",
                "customer_phone":"+919999999999",
                "customer_address":"Powai Lake, Powai, Mumbai, Maharashtra, India",
                "latitude":"28.5494489",
                "longitude":"77.2001368",
                "job_description":"Beauty services",
                "job_pickup_datetime":"2016-09-30 16:00:00",
                "job_delivery_datetime":"2016-09-30 17:00:00",
                "has_pickup":"0",
                "has_delivery":"0",
                "layout_type":"1",
                "tracking_link":1,
                "timezone":"-330",
                "api_key":"2b997be77e2cc22becfd4c66426ef504",
                "job_id":2952,
                "notify": 1
            }

+ Response 200 (application/json)


    + Body

                {
                  "message": "Successful",
                  "status": 200,
                  "data": {}
                }

## Edit Multiple Tasks [/edit_multiple_tasks]

### Edit Multiple Tasks [POST]

This API is used to edit multiple tasks that are already added. It takes as input the array of pickup and delivery tasks and one by one updates their data.

Request Parameters:

<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">pickups*</td><td>json array</td><td>This json array contains the pickup tasks the you want to edit. The format of each pickup task is same as defined in the create multiple tasks section.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">deliveries*</td><td>json array</td><td>This json array contains the delivery tasks the you want to edit. The format of each delivery task is same as defined in the create multiple tasks section.</td></tr>
</table>

+ Request (application/json)

        {
            "api_key":"7fed9dc6f41eb088bb49ab5344685d13",
            "pickups":[{
                        "job_id":"123344",
                        "address": "Chandigarh International Airport, Sahibzada Ajit Singh Nagar, Punjab, India",
                        "latitude": 30.7333148,
                        "longitude": 76.7794179,
                        "time": "2017-08-14 17:24:00",
                        "phone": "+911234567890"
                        }],
            "deliveries":[{
                        "job_id":"123345",
                        "address": "Chandigarh Railway Station, Daria, Chandigarh, India",
                        "latitude": 30.7022191,
                        "longitude": 76.82247009999992,
                        "time": "2017-08-14 17:30:00",
                        "phone": "+913242342342"
                        }]
        }
        
+ Response 200 (application/json)

        {
            "message":"Successful",
            "status":200,
            "data":{}
        }

## Change Task Datetime [/change_job_date]

### Change Task Datetime [POST]

This API is used to change datetime of multiple tasks that are already added. It takes as input the array of task id's and one by one update the datetime for all the tasks.

Request Parameters:

<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_ids*</td><td>array</td><td>This array contains the task id's the you want to edit.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">layout_type*</td><td>number</td><td>For Pickup & Delivery, it's value is 0. For Appointment, it's value is 1. For FOS, it's value is 2.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">start_time*</td><td>datetime</td><td>Enter the datetime of the pickup tasks. For Appointment/FOS, it refers to start time of the task.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">end_time*</td><td>datetime</td><td>Enter the datetime of the delivery tasks. For Appointment/FOS, it refers to end time of the task.</td></tr>
</table>

+ Request (application/json)

        {
    "api_key": "55646583f01653421d142e7a4204414e2cdfb2bd57a3b5f",
    "job_ids": [
        "3360",
        "3368",
        "3967"
    ],
    "layout_type": 0,
    "start_time": "2019-04-26 11:00:00",
    "end_time": "2019-04-26 11:30:00"
}
        
+ Response 200 (application/json)

        {
            "message":"Bulk Date Change is in progress. It may take a few seconds.",
            "status":200,
            "data":{}
        }

## Delete Task [/delete_task]

### Delete Task [POST]

This API is used to Delete a task which is not necessary.

Request Body Parameters:
<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_id*</td><td>number</td><td>You can get it from task details.</td></tr>
</table>
+ Request (application/json)

            {
                "api_key": "2b997be77e2cc22becfd4c66426ef504",
                "job_id": "2755"
            }

+ Response 200 (application/json)


        {
            "message": "Successful",
            "status": 200,
            "data": {}
        }

## Update Task Status [/update_task_status]

### Update Task Status [POST]

This API is used to force update the status of a task.

Request Body Parameters:
<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
<tr><td style="padding-left: 0;" colspan="2">api_key</td><td>string</td><td> You can get a key from settings(Login>Menu>Settings>API Keys) in your tookan account. Or <a href="https://app.tookanapp.com/#/app/settings/apikey">click here</a> to get API key</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_id*</td><td>string (single or comma separated values)</td><td>You can get it from task details.</td></tr>
<tr><td style="padding-left: 0;" colspan="2">job_status*</td><td>number</td><td>Refer status codes section above for various statuses available.</td></tr>
</table>

+ Request (application/json)

            {
                "api_key": "2b997be77e2cc22becfd4c66426ef504",
                "job_id": "5145",
                "job_status": "2"
            }

+ Response 200 (application/json)


        {
          "message": "Successful",
          "status": 200,
          "data": {}
        }

## Ready to Dispatch [/ready_to_dispatch]

### Ready to Dispatch [POST]

Upon requested, this API sends push notifications to the Agent Application following the assignment of an agent to a designated task. Additionally, it sends a webhook aligned with the "Ready to dispatch" event.

Request Body Parameters:
<table>
<tr><td style="padding-left: 0;" colspan="2"><strong>Name</strong><td><strong>Type</strong></td><td><strong>Description</strong></td></tr>
[...]
